/** @file bayer2rgb-cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef BAYER2RGB_CMDLINE_H
#define BAYER2RGB_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

enum enum_method { method__NULL = -1, method_arg_c = 0, method_arg_cc, method_arg_cMINUS_opt, method_arg_neon };
enum enum_quality { quality__NULL = -1, quality_arg_PLUS_round4 = 0, quality_arg_PLUS_round2, quality_arg_PLUS_round, quality_arg_MINUS_round4, quality_arg_MINUS_round2, quality_arg_MINUS_round, quality_arg_PLUS_all, quality_arg_MINUS_all };
enum enum_input_format { input_format__NULL = -1, input_format_arg_gbrg = 0, input_format_arg_bggr, input_format_arg_rggb, input_format_arg_grbg };
enum enum_output_format { output_format__NULL = -1, output_format_arg_rgbx = 0, output_format_arg_bgrx, output_format_arg_xrgb, output_format_arg_xbgr, output_format_arg_ppm, output_format_arg_rgb, output_format_arg_rgb16 };

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int width_arg;	/**< @brief Input frame width.  */
  char * width_orig;	/**< @brief Input frame width original value given at command line.  */
  const char *width_help; /**< @brief Input frame width help description.  */
  int height_arg;	/**< @brief Input frame height.  */
  char * height_orig;	/**< @brief Input frame height original value given at command line.  */
  const char *height_help; /**< @brief Input frame height help description.  */
  enum enum_method method_arg;	/**< @brief conversion method (default='c').  */
  char * method_orig;	/**< @brief conversion method original value given at command line.  */
  const char *method_help; /**< @brief conversion method help description.  */
  int silent_flag;	/**< @brief be quiet (default=off).  */
  const char *silent_help; /**< @brief be quiet help description.  */
  enum enum_quality *quality_arg;	/**< @brief quality flags.  */
  char ** quality_orig;	/**< @brief quality flags original value given at command line.  */
  unsigned int quality_min; /**< @brief quality flags's minimum occurreces */
  unsigned int quality_max; /**< @brief quality flags's maximum occurreces */
  const char *quality_help; /**< @brief quality flags help description.  */
  enum enum_input_format input_format_arg;	/**< @brief input format (default='gbrg').  */
  char * input_format_orig;	/**< @brief input format original value given at command line.  */
  const char *input_format_help; /**< @brief input format help description.  */
  int input_bpp_arg;	/**< @brief input bpp (default='8').  */
  char * input_bpp_orig;	/**< @brief input bpp original value given at command line.  */
  const char *input_bpp_help; /**< @brief input bpp help description.  */
  int input_crop_x_arg;	/**< @brief left column of input (default='0').  */
  char * input_crop_x_orig;	/**< @brief left column of input original value given at command line.  */
  const char *input_crop_x_help; /**< @brief left column of input help description.  */
  int input_crop_y_arg;	/**< @brief top row of input (default='0').  */
  char * input_crop_y_orig;	/**< @brief top row of input original value given at command line.  */
  const char *input_crop_y_help; /**< @brief top row of input help description.  */
  int input_crop_w_arg;	/**< @brief input image width .  */
  char * input_crop_w_orig;	/**< @brief input image width  original value given at command line.  */
  const char *input_crop_w_help; /**< @brief input image width  help description.  */
  int input_crop_h_arg;	/**< @brief input image height .  */
  char * input_crop_h_orig;	/**< @brief input image height  original value given at command line.  */
  const char *input_crop_h_help; /**< @brief input image height  help description.  */
  enum enum_output_format output_format_arg;	/**< @brief output format (default='rgbx').  */
  char * output_format_orig;	/**< @brief output format original value given at command line.  */
  const char *output_format_help; /**< @brief output format help description.  */
  int output_bpp_arg;	/**< @brief output bpp (default='32').  */
  char * output_bpp_orig;	/**< @brief output bpp original value given at command line.  */
  const char *output_bpp_help; /**< @brief output bpp help description.  */
  int output_width_arg;	/**< @brief output frame width.  */
  char * output_width_orig;	/**< @brief output frame width original value given at command line.  */
  const char *output_width_help; /**< @brief output frame width help description.  */
  int output_height_arg;	/**< @brief output frame height.  */
  char * output_height_orig;	/**< @brief output frame height original value given at command line.  */
  const char *output_height_help; /**< @brief output frame height help description.  */
  int output_window_x_arg;	/**< @brief left column of output window (default='0').  */
  char * output_window_x_orig;	/**< @brief left column of output window original value given at command line.  */
  const char *output_window_x_help; /**< @brief left column of output window help description.  */
  int output_window_y_arg;	/**< @brief top row of output window (default='0').  */
  char * output_window_y_orig;	/**< @brief top row of output window original value given at command line.  */
  const char *output_window_y_help; /**< @brief top row of output window help description.  */
  int output_window_w_arg;	/**< @brief input image output window .  */
  char * output_window_w_orig;	/**< @brief input image output window  original value given at command line.  */
  const char *output_window_w_help; /**< @brief input image output window  help description.  */
  int output_window_h_arg;	/**< @brief input image output window .  */
  char * output_window_h_orig;	/**< @brief input image output window  original value given at command line.  */
  const char *output_window_h_help; /**< @brief input image output window  help description.  */
  int dump_info_flag;	/**< @brief dump only image information (default=off).  */
  const char *dump_info_help; /**< @brief dump only image information help description.  */
  int loop_arg;	/**< @brief run conversion <CNT> times (default='1').  */
  char * loop_orig;	/**< @brief run conversion <CNT> times original value given at command line.  */
  const char *loop_help; /**< @brief run conversion <CNT> times help description.  */
  int timing_flag;	/**< @brief show timing information (default=off).  */
  const char *timing_help; /**< @brief show timing information help description.  */
  int flush_cache_flag;	/**< @brief flush cache between conversions (default=off).  */
  const char *flush_cache_help; /**< @brief flush cache between conversions help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int width_given ;	/**< @brief Whether width was given.  */
  unsigned int height_given ;	/**< @brief Whether height was given.  */
  unsigned int method_given ;	/**< @brief Whether method was given.  */
  unsigned int silent_given ;	/**< @brief Whether silent was given.  */
  unsigned int quality_given ;	/**< @brief Whether quality was given.  */
  unsigned int input_format_given ;	/**< @brief Whether input-format was given.  */
  unsigned int input_bpp_given ;	/**< @brief Whether input-bpp was given.  */
  unsigned int input_crop_x_given ;	/**< @brief Whether input-crop-x was given.  */
  unsigned int input_crop_y_given ;	/**< @brief Whether input-crop-y was given.  */
  unsigned int input_crop_w_given ;	/**< @brief Whether input-crop-w was given.  */
  unsigned int input_crop_h_given ;	/**< @brief Whether input-crop-h was given.  */
  unsigned int output_format_given ;	/**< @brief Whether output-format was given.  */
  unsigned int output_bpp_given ;	/**< @brief Whether output-bpp was given.  */
  unsigned int output_width_given ;	/**< @brief Whether output-width was given.  */
  unsigned int output_height_given ;	/**< @brief Whether output-height was given.  */
  unsigned int output_window_x_given ;	/**< @brief Whether output-window-x was given.  */
  unsigned int output_window_y_given ;	/**< @brief Whether output-window-y was given.  */
  unsigned int output_window_w_given ;	/**< @brief Whether output-window-w was given.  */
  unsigned int output_window_h_given ;	/**< @brief Whether output-window-h was given.  */
  unsigned int dump_info_given ;	/**< @brief Whether dump-info was given.  */
  unsigned int loop_given ;	/**< @brief Whether loop was given.  */
  unsigned int timing_given ;	/**< @brief Whether timing was given.  */
  unsigned int flush_cache_given ;	/**< @brief Whether flush-cache was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_method_values[];  /**< @brief Possible values for method. */
extern const char *cmdline_parser_quality_values[];  /**< @brief Possible values for quality. */
extern const char *cmdline_parser_input_format_values[];  /**< @brief Possible values for input-format. */
extern const char *cmdline_parser_output_format_values[];  /**< @brief Possible values for output-format. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* BAYER2RGB_CMDLINE_H */
