/** @file gen-image-cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef GEN_IMAGE_CMDLINE_H
#define GEN_IMAGE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE PACKAGE
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#ifdef PACKAGE_NAME
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE_NAME
#else
#define CMDLINE_PARSER_PACKAGE_NAME PACKAGE
#endif
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

enum enum_method { method__NULL = -1, method_arg_solid = 0, method_arg_random, method_arg_seq, method_arg_column };
enum enum_format { format__NULL = -1, format_arg_gbrg = 0, format_arg_bggr, format_arg_rggb, format_arg_grbg };

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  enum enum_method method_arg;	/**< @brief Method.  */
  char * method_orig;	/**< @brief Method original value given at command line.  */
  const char *method_help; /**< @brief Method help description.  */
  int width_arg;	/**< @brief image width.  */
  char * width_orig;	/**< @brief image width original value given at command line.  */
  const char *width_help; /**< @brief image width help description.  */
  int height_arg;	/**< @brief image height.  */
  char * height_orig;	/**< @brief image height original value given at command line.  */
  const char *height_help; /**< @brief image height help description.  */
  int bpp_arg;	/**< @brief bpp (default='8').  */
  char * bpp_orig;	/**< @brief bpp original value given at command line.  */
  const char *bpp_help; /**< @brief bpp help description.  */
  enum enum_format format_arg;	/**< @brief format (default='gbrg').  */
  char * format_orig;	/**< @brief format original value given at command line.  */
  const char *format_help; /**< @brief format help description.  */
  int red_arg;	/**< @brief red component (default='0').  */
  char * red_orig;	/**< @brief red component original value given at command line.  */
  const char *red_help; /**< @brief red component help description.  */
  int green_arg;	/**< @brief green component (default='0').  */
  char * green_orig;	/**< @brief green component original value given at command line.  */
  const char *green_help; /**< @brief green component help description.  */
  int blue_arg;	/**< @brief blue component (default='0').  */
  char * blue_orig;	/**< @brief blue component original value given at command line.  */
  const char *blue_help; /**< @brief blue component help description.  */
  int grey_arg;	/**< @brief grey value.  */
  char * grey_orig;	/**< @brief grey value original value given at command line.  */
  const char *grey_help; /**< @brief grey value help description.  */
  int seed_arg;	/**< @brief seed.  */
  char * seed_orig;	/**< @brief seed original value given at command line.  */
  const char *seed_help; /**< @brief seed help description.  */
  int column_arg;	/**< @brief column to be set (default='0').  */
  char * column_orig;	/**< @brief column to be set original value given at command line.  */
  const char *column_help; /**< @brief column to be set help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int method_given ;	/**< @brief Whether method was given.  */
  unsigned int width_given ;	/**< @brief Whether width was given.  */
  unsigned int height_given ;	/**< @brief Whether height was given.  */
  unsigned int bpp_given ;	/**< @brief Whether bpp was given.  */
  unsigned int format_given ;	/**< @brief Whether format was given.  */
  unsigned int red_given ;	/**< @brief Whether red was given.  */
  unsigned int green_given ;	/**< @brief Whether green was given.  */
  unsigned int blue_given ;	/**< @brief Whether blue was given.  */
  unsigned int grey_given ;	/**< @brief Whether grey was given.  */
  unsigned int seed_given ;	/**< @brief Whether seed was given.  */
  unsigned int column_given ;	/**< @brief Whether column was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);

extern const char *cmdline_parser_method_values[];  /**< @brief Possible values for method. */
extern const char *cmdline_parser_format_values[];  /**< @brief Possible values for format. */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* GEN_IMAGE_CMDLINE_H */
